#!/bin/env python

# caolanm@redhat.com

#notes:
#    1. this might totally break your blog, don't come crying
#    2. would be nice to use the xhtml export instead of html, but it's slow...
#    3. only blogger.com ATOM support works at the moment, the menus lie
#    4. would like to use the "Info 1" etc fields instead of subject, etc, but 
#       too lazy to figure them out

import xmlrpclib, tempfile, urllib, urllib2, base64, httplib
import xml.sax.saxutils, os.path, os, traceback
from xml.dom.minidom import parse
from time import gmtime, strftime, localtime

import uno, unohelper
from com.sun.star.awt.WindowClass import TOP, SIMPLE
from com.sun.star.awt.PushButtonType import CANCEL, OK
from com.sun.star.awt.TextAlign import LEFT, CENTER
from com.sun.star.awt import XItemListener
from com.sun.star.beans import PropertyValue
from com.sun.star.task import XJob

appkey = 'OpenOffice.org Blogger'

class post:
	def __init__(self, title, draft, content, editurl):
		self.title = title
		self.draft = draft
		self.content = content
		self.editurl = editurl

class blog:
	def __init__(self, name, posts):
		self.name = name
		self.posts = posts

def getText(nodelist):
	rc = ""
	for node in nodelist:
		if node.nodeType == node.TEXT_NODE:
			rc = rc + node.data
	return rc

def buildreq(username, password, url):
	req = urllib2.Request(url)
	base64string = base64.encodestring('%s:%s' % (username, password))[:-1]
	req.add_header("Authorization", "Basic %s" % base64string)
	return req

def urlget(username, password, url):
	req = buildreq(username, password, url)
	return urllib2.urlopen(req)

def urlpost(username, password, url, content):
	req = buildreq(username, password, url)
	req.add_data(content)
	req.add_header("Content-type", "application/xml")
	return urllib2.urlopen(req)

def openatomblogfromdom(dom):
	posts = []
	entries = dom.getElementsByTagName("entry")
	i = 0
	for entry in entries:
		links = entry.getElementsByTagName("link")
		for link in links:
			if link.attributes["rel"].value == 'service.edit':
				editurl = link.attributes["href"].value

		titles = entry.getElementsByTagName("title")
		if len(titles):
			title = getText(titles[0].childNodes)
		else:
			title = None
		draft = False
		drafts = entry.getElementsByTagName("draft")
		if len(drafts):
			if 'true' == getText(drafts[0].childNodes).lower():
				draft = True
		contents = entry.getElementsByTagName("content")
		if len(contents):
			contentnode = contents[0]
			escaped = False
			if contentnode.attributes.has_key('mode') and \
				contentnode.attributes["mode"].value == \
					'escaped':
				escaped = True
			body = ''
			for content in contentnode.childNodes:
				body = body + content.toxml()
			if escaped:
				body = xml.sax.saxutils.unescape(body)
			apost = post(title, draft, body, editurl)
			posts.append(apost)
	return posts


def openatomblog(href, username, password):
	datasource = urlget(username, password, href)
	dom = parse(datasource)
	datasource.close()
	return openatomblogfromdom(dom)

def getatomblogsandposts(username, password, serverurl):
	datasource = urlget(username, password, serverurl)
	dom = parse(datasource)
	datasource.close()

	links = dom.getElementsByTagName("link")
	blogfeeds = {}
	for link in links:
		if link.attributes["rel"].value == 'service.feed':
			blogfeeds[link.attributes["href"].value] = \
				link.attributes["title"].value
	dom.unlink()
	
	blogs = []
	for href in blogfeeds.keys():
		posts = openatomblog(href, username, password)
		ablog = blog(blogfeeds[href], posts)
		blogs.append(ablog)
	return blogs

def getatomposturls(username, password, serverurl):
	datasource = urlget(username, password, serverurl)
	dom = parse(datasource)
	datasource.close()

	links = dom.getElementsByTagName("link")
	blogposts = {}
	for link in links:
		if link.attributes["rel"].value == 'service.post':
			blogposts[link.attributes["href"].value] = \
				link.attributes["title"].value
	dom.unlink()

	return blogposts

def postmetablog(login, handle, content, title, draft):
	entry = {}
        entry['title'] = title
        entry['description'] = content

	username = login['username']
	password = login['password']
	serverurl = login['serverurl']

	blogserver = xmlrpclib.Server(serverurl)
	blogserver.metaWeblog.newPost(handle, username, password, entry, 
		xmlrpclib.True)
	posts = getmetaposts(handle, username, password, serverurl, 1)
	return posts[0]

def postatomblog(login, serverurl, content, title, draft):
	result = \
	    '<?xml version="1.0" encoding="UTF-8" standalone="yes"?>'
	result = result + \
	    '<entry xmlns="http://purl.org/atom/ns#">'
	result = result + \
	    '<title mode="escaped" type="text/plain">' + title + '</title>'
	result = result + \
	    '<issued>' + strftime("%Y-%m-%dT%H:%M:%SZ", gmtime()) + '</issued>'
	if draft:
		result = result + \
	    	'<draft xmlns="http://purl.org/atom-blog/ns#">true</draft>'
	result = result + \
        '<generator url="http://www.foo.org">foo.org</generator>'
	result = result + '<content mode="escaped" type="text/html">'

	content = xml.sax.saxutils.escape(content)
	result = str(result) + str(content)

	result = result + '</content>' + '</entry>'

	ret = urlpost(login['username'], login['password'], serverurl, result)
	dom = parse(ret)
	ret.close()
	posts = openatomblogfromdom(dom)
	return posts[0]

def getmetablogs(username, password, serverurl):
	blogserver = xmlrpclib.Server(serverurl)

#	methods = blogserver.system.listMethods()
#	print 'methods are', methods

	blogs = {}
	# blog["blogName"], blog["blogid"], blog["url"]
	data = blogserver.metaWeblog.getUsersBlogs(appkey, username, password)
	for datum in data:
		blogs[datum["blogid"]] = datum["blogName"]
	return blogs

def getmetablogsandposts(username, password, serverurl):
	getmetablogs(username, password, serverurl)

	blogserver = xmlrpclib.Server(serverurl)

	blogs = []
	items = getmetablogs(username, password, serverurl)
	for key in items.keys():
		posts = getmetaposts(key, username, password, serverurl)
		ablog = blog(items[key], posts)
		blogs.append(ablog)
	return blogs

def getmetaposts(blogid, username, password, serverurl, count=15):
	blogserver = xmlrpclib.Server(serverurl)
	metaposts = blogserver.metaWeblog.getRecentPosts(blogid, \
		username, password, count)
	posts = []
	for metapost in metaposts:
		content = metapost['description'].replace('\n', '<br>')
		apost = post(metapost['title'], False, content, \
			metapost['postid'])
		posts.append(apost)
	return posts

class BlogListListener(unohelper.Base, XItemListener):
    def __init__(self, dialog, blogs):
        self.dialog = dialog
	self.blogs = blogs
    def disposing(self, eventObject):
        pass
    def itemStateChanged(self, itemEvent):
        postlist = self.dialog.getControl('PostList')
	count = postlist.getItemCount()
	postlist.removeItems(0, count)

        bloglist = self.dialog.getControl('BlogList')
        selected = bloglist.getSelectedItemPos()
	posts = self.blogs[selected].posts
	postslen = len(posts)
	if postslen:
		for i in range(0, postslen):
			postlist.addItem(posts[i].title, i)
		postlist.selectItemPos(0, True)

def SavePost():
	login = fetchlogindetails()

	ctx = uno.getComponentContext()
	smgr = ctx.ServiceManager
        desktop = smgr.createInstanceWithContext(\
		"com.sun.star.frame.Desktop", ctx)
	xDoc = desktop.getCurrentComponent()

	if login['rpctype'] == 1:
		blogposts = getatomposturls(login['username'], \
			login['password'], getserverurl(login))
	else:
		blogposts = getmetablogs(login['username'], \
			login['password'], login['serverurl'])

	info = xDoc.getDocumentInfo()
        title = info.getPropertyValue( "Title" )
	if not len(title):
		title = 'Untitled'

        editurl = info.getPropertyValue( "Subject" )

	model = smgr.createInstanceWithContext(
        	'com.sun.star.awt.UnoControlDialogModel', ctx)
	model.PositionX = 50
        model.Step = 1
        model.TabIndex = 7
        model.Width = 132
        model.Height = 115
        model.PositionY = 63

        ok = model.createInstance(
        	'com.sun.star.awt.UnoControlButtonModel')
        ok.PositionX = 30
        ok.TabIndex = 1
        ok.Height = 12
        ok.Width = 48
        ok.PositionY = 95
        ok.PushButtonType = OK
        ok.DefaultButton =  True
        ok.Label = 'OK'
        model.insertByName('BtnOK', ok )

        cancel = model.createInstance(
        	'com.sun.star.awt.UnoControlButtonModel')
        cancel.PositionX = 80
        cancel.TabIndex = 2
        cancel.Height = 12
        cancel.Width = 48
        cancel.PositionY = 95
        cancel.PushButtonType = CANCEL
        cancel.Label = 'Cancel'
        model.insertByName('BtnExit', cancel )

	titlelabel = model.createInstance(
		'com.sun.star.awt.UnoControlFixedTextModel')
        titlelabel.PositionX = 5
        titlelabel.TabIndex = 3
        titlelabel.Width = 20
        titlelabel.Height = 10
        titlelabel.PositionY = 20
        titlelabel.Align = LEFT
        titlelabel.Label = 'Title:'
        model.insertByName('TitleLabel', titlelabel)

	titleentry = model.createInstance(
		'com.sun.star.awt.UnoControlEditModel')
        titleentry.PositionX = 25
        titleentry.TabIndex = 3
        titleentry.Width = 100
        titleentry.Height = 10
        titleentry.PositionY = 20
        titleentry.Align = LEFT
	titleentry.Text = title
        model.insertByName('TitleEntry', titleentry)

	bloglabel = model.createInstance(
		'com.sun.star.awt.UnoControlFixedTextModel')
        bloglabel.PositionX = 5
        bloglabel.TabIndex = 3
        bloglabel.Width = 30
        bloglabel.Height = 10
        bloglabel.PositionY = 42
        bloglabel.Align = LEFT
        bloglabel.Label = 'Select Blog'
        model.insertByName('BlogLabel', bloglabel)

        bloglist= model.createInstance(
		'com.sun.star.awt.UnoControlListBoxModel')
        bloglist.PositionX = 5
        bloglist.TabIndex = 6
        bloglist.Width = 120
        bloglist.Height = 10
        bloglist.PositionY = 52
        bloglist.Dropdown =  True
        model.insertByName('BlogList', bloglist )

        draftradio = model.createInstance(
		'com.sun.star.awt.UnoControlCheckBoxModel')
        draftradio.PositionX = 5
        draftradio.Height = 10
        draftradio.Width = 60
        draftradio.PositionY = 73
        draft = info.getPropertyValue( "Keywords" )
	if len(draft):
        	draftradio.State = True
	else:
        	draftradio.State = False
        draftradio.Label = 'Post as Draft'
	if login['rpctype'] == 1:
        	model.insertByName('DraftRadio', draftradio )

	replaceradio = model.createInstance(
		'com.sun.star.awt.UnoControlCheckBoxModel')
	replaceradio.PositionX = 50
	replaceradio.Height = 10
	replaceradio.Width = 80
	replaceradio.PositionY = 73
	replaceradio.State = False
	replaceradio.Label = 'Replace Original Post'
	if len(editurl):
		replaceradio.State = True
		model.insertByName('ReplaceRadio', replaceradio )


        frame = model.createInstance(
		'com.sun.star.awt.UnoControlGroupBoxModel')
        frame.PositionX = 1
        frame.TabIndex = 0
        frame.Height = 90
        frame.Width = 130
        frame.PositionY = 1
        frame.Label = 'Post Details'
        model.insertByName('Frame', frame)

	dialog = smgr.createInstanceWithContext(
		'com.sun.star.awt.UnoControlDialog', ctx)

	dialog.setModel(model)

        toolkit = smgr.createInstanceWithContext(
		'com.sun.star.awt.Toolkit', ctx)
        a_rect = uno.createUnoStruct( 'com.sun.star.awt.Rectangle' )
        a_rect.X = model.PositionX
        a_rect.Width = model.Width
        a_rect.Height = model.Height
        a_rect.Y = model.PositionY
        win_descriptor = uno.createUnoStruct(\
		'com.sun.star.awt.WindowDescriptor')
        win_descriptor.Type = TOP
        win_descriptor.ParentIndex = -1
        win_descriptor.Bounds = a_rect
        peer = toolkit.createWindow( win_descriptor )
        dialog.createPeer( toolkit, peer )

	dialog.setTitle ( "Blogging" )

        blogs = dialog.getControl('BlogList')
	blogindexs = []
	i = 0
	for handle in blogposts.keys():
		blogs.addItem(blogposts[handle], i)
		blogindexs.append(handle)
		i = i + 1
	blogs.selectItemPos(0, True)

	ret = dialog.execute()

	if not ret:
		return

	postdump = tempfile.NamedTemporaryFile()
	outurl = 'file://' + urllib.pathname2url(postdump.name)

	properties=[]
	p=PropertyValue()
	p.Name='FilterName'
	p.Value="HTML (StarWriter)"
	properties.append(p)

	xDoc.storeToURL(outurl, tuple(properties))

#	properties=[]
#	p = PropertyValue()
#	p.Name = "FilterName"
#	p.Value = "HTML";
#	properties.append(p)
#
#       xpostSaveDoc = desktop.loadComponentFromURL(outurl, '_hidden', 0, \
#                tuple(properties))
#
#	traverse xpostSaveDoc for file:/// graphic links and upload them

	datasource = open(postdump.name)

	#yuck, but the xhtml save is real slow
	content = datasource.readlines()
	datasource.close()
	for i in range(0, len(content)):
		line = content[i]
		if (len(line) > 5) and line[0:5] == '<BODY':
			i = i + 1
			break

	result = ''
	for i in range(i, len(content)):
		line = content[i]
		if (len(line) > 5) and line[0:6] == '</BODY':
			break
		result = result + line[:-1]

	if replaceradio.State:
		posthandle = editurl
	else:
		posthandle = blogindexs[blogs.getSelectedItemPos()]

	if login['rpctype'] == 1:
		blog = postatomblog(login, posthandle, result, \
			titleentry.Text, draftradio.State)
	else:
		blog = postmetablog(login, posthandle, result, \
			titleentry.Text, draftradio.State)

	blogtoinfo(blog, info)

def blogtoinfo(blog, info):
	info.setPropertyValue( "Title", blog.title )
	info.setPropertyValue( "Subject", blog.editurl )
	if blog.draft:
		info.setPropertyValue( "Keywords", "draft" )

def ShowPosts():
	login = fetchlogindetails()

	ctx = uno.getComponentContext()
	smgr = ctx.ServiceManager

	model = smgr.createInstanceWithContext(
        	'com.sun.star.awt.UnoControlDialogModel', ctx)
	model.PositionX = 50
        model.Step = 1
        model.TabIndex = 7
        model.Width = 132
        model.Height = 135
        model.PositionY = 63

        ok = model.createInstance(
        	'com.sun.star.awt.UnoControlButtonModel')
        ok.PositionX = 30
        ok.TabIndex = 1
        ok.Height = 12
        ok.Width = 48
        ok.PositionY = 120
        ok.PushButtonType = OK
        ok.DefaultButton =  True
        ok.Label = 'OK'
        model.insertByName('BtnOK', ok )

        cancel = model.createInstance(
        	'com.sun.star.awt.UnoControlButtonModel')
        cancel.PositionX = 80
        cancel.TabIndex = 2
        cancel.Height = 12
        cancel.Width = 48
        cancel.PositionY = 120
        cancel.PushButtonType = CANCEL
        cancel.Label = 'Cancel'
        model.insertByName('BtnExit', cancel )

	bloglabel = model.createInstance(
		'com.sun.star.awt.UnoControlFixedTextModel')
        bloglabel.PositionX = 5
        bloglabel.TabIndex = 3
        bloglabel.Width = 30
        bloglabel.Height = 10
        bloglabel.PositionY = 20
        bloglabel.Align = LEFT
        bloglabel.Label = 'Select Blog'
        model.insertByName('BlogLabel', bloglabel)

        postlist= model.createInstance(
		'com.sun.star.awt.UnoControlListBoxModel')
        postlist.PositionX = 5
        postlist.TabIndex = 4
        postlist.Width = 120
        postlist.Height = 50
        postlist.PositionY = 62
        postlist.Dropdown =  False
        postlist.LineCount = 15
        model.insertByName('PostList', postlist )

	postlabel = model.createInstance(
		'com.sun.star.awt.UnoControlFixedTextModel')
        postlabel.PositionX = 5
        postlabel.TabIndex = 5
        postlabel.Width = 32
        postlabel.Height = 10
        postlabel.PositionY = 50
        postlabel.Align = LEFT
        postlabel.Label = 'Select Post'
        model.insertByName('PostLabel', postlabel)

        bloglist= model.createInstance(
		'com.sun.star.awt.UnoControlListBoxModel')
        bloglist.PositionX = 5
        bloglist.TabIndex = 6
        bloglist.Width = 120
        bloglist.Height = 10
        bloglist.PositionY = 30
        bloglist.Dropdown =  True
        model.insertByName('BlogList', bloglist )

        frame = model.createInstance(
		'com.sun.star.awt.UnoControlGroupBoxModel')
        frame.PositionX = 1
        frame.TabIndex = 0
        frame.Height = 115
        frame.Width = 130
        frame.PositionY = 1
        frame.Label = 'Open Post'
        model.insertByName('Frame', frame)

	dialog = smgr.createInstanceWithContext(
		'com.sun.star.awt.UnoControlDialog', ctx)

	dialog.setModel(model)

        toolkit = smgr.createInstanceWithContext(
		'com.sun.star.awt.Toolkit', ctx)
        a_rect = uno.createUnoStruct( 'com.sun.star.awt.Rectangle' )
        a_rect.X = model.PositionX
        a_rect.Width = model.Width
        a_rect.Height = model.Height
        a_rect.Y = model.PositionY
        win_descriptor = uno.createUnoStruct(\
		'com.sun.star.awt.WindowDescriptor')
        win_descriptor.Type = TOP
        win_descriptor.ParentIndex = -1
        win_descriptor.Bounds = a_rect
        peer = toolkit.createWindow( win_descriptor )
        dialog.createPeer( toolkit, peer )

	dialog.setTitle ( "Open Post" )

	try:
		if login['rpctype'] == 1:
			userblogs = getatomblogsandposts(login['username'], \
				login['password'], getserverurl(login))
		else:
			userblogs = getmetablogsandposts(login['username'], \
				login['password'], getserverurl(login))
	except:
		error = traceback.format_exc()
		dialog.dispose()
		ShowError(error)
		return

	whichblog = BlogListListener(dialog, userblogs)
	blogs = dialog.getControl('BlogList')
	blogs.addItemListener(whichblog)

	if userblogs:
		userblogslen = len(userblogs)
		if userblogslen:
			for i in range(0, userblogslen):
				blogs.addItem(userblogs[i].name, i)
			blogs.selectItemPos(0, True)

	ret = dialog.execute()

	blogs.removeItemListener(whichblog)

	if not ret:
		return
	posts = dialog.getControl('PostList')
	if posts.getItemCount():
		apost = userblogs[blogs.getSelectedItemPos()].posts[posts.getSelectedItemPos()]
	dialog.dispose()
	try:
		openpost(apost)
	except:
		ShowError(traceback.format_exc())

def getserverurl(login):
	selected = int(login['servertype'])
	if selected == 0:
		return 'https://www.blogger.com/atom'
	elif selected == 1:
		return 'http://www.livejournal.com/interface/xmlrpc'
	elif selected == 2:
		return 'http://www.advogato.org/XMLRPC'
	else:
		return login['serverurl']

class ServerListListener(unohelper.Base, XItemListener):
    def __init__(self, dialog):
        self.dialog = dialog
    def disposing(self, eventObject):
        pass
    def itemStateChanged(self, itemEvent):
        urlentry = self.dialog.getControl('UrlEntry')
        rpctype = self.dialog.getControl('RPCList')

        bloglist = self.dialog.getControl('BlogList')
        selected = bloglist.getSelectedItemPos()
	if selected == 0:
		rpctype.Enable = False
		rpctype.selectItemPos(1, True)
		urlentry.Enable = False
		urlentry.setText('https://www.blogger.com/atom')
	elif selected == 1:
		rpctype.Enable = False
		rpctype.selectItemPos(0, True)
		urlentry.Enable = False
		urlentry.setText('http://www.livejournal.com/interface/xmlrpc')
	elif selected == 2:
		rpctype.Enable = False
		rpctype.selectItemPos(0, True)
		urlentry.Enable = False
		urlentry.setText('http://www.advogato.org/XMLRPC')
	else:
		login = logindetails()
		rpctype.Enable = True
		rpctype.selectItemPos(login['rpctype'], True)
		urlentry.Enable = True
		urlentry.setText(login['serverurl'])

def logindetails():
	login = {}
	login['username'] = ''
	login['password'] = 'password'
	login['servertype'] = 0
	login['rpctype'] = 1
	login['serverurl'] = 'http://'
	try:
		config = open(os.path.expanduser('~/.oooblog'), "r")
		lines = config.readlines()
		login['username'] = lines[0][:-1]
		login['password'] = lines[1][:-1]
		login['servertype'] = lines[2][:-1]
		login['rpctype'] = lines[3][:-1]
		login['serverurl'] = lines[4][:-1]
		config.close()
	except:
		pass
	return login

def fetchlogindetails():
	login = logindetails()
	if not len(login['username']):
		GetSettings()
		login = logindetails()
	return login

def GetSettings():
	login = logindetails()

	ctx = uno.getComponentContext()
	smgr = ctx.ServiceManager

	model = smgr.createInstanceWithContext(
        	'com.sun.star.awt.UnoControlDialogModel', ctx)
	model.PositionX = 50
        model.Step = 1
        model.TabIndex = 7
        model.Width = 172
        model.Height = 100
        model.PositionY = 64

	userlabel = model.createInstance(
		'com.sun.star.awt.UnoControlFixedTextModel')
        userlabel.PositionX = 5
        userlabel.TabIndex = 3
        userlabel.Width = 30
        userlabel.Height = 10
        userlabel.PositionY = 15
        userlabel.Align = LEFT
        userlabel.Label = 'Username:'
        model.insertByName('UserLabel', userlabel)

	userentry = model.createInstance(
		'com.sun.star.awt.UnoControlEditModel')
        userentry.PositionX = 55
        userentry.TabIndex = 3
        userentry.Width = 110
        userentry.Height = 10
        userentry.PositionY = 15
        userentry.Align = LEFT
        userentry.Text = login['username']
        model.insertByName('UserEntry', userentry)

	passlabel = model.createInstance(
		'com.sun.star.awt.UnoControlFixedTextModel')
        passlabel.PositionX = 5
        passlabel.TabIndex = 3
        passlabel.Width = 30
        passlabel.Height = 10
        passlabel.PositionY = 27
        passlabel.Align = LEFT
        passlabel.Label = 'Password:'
        model.insertByName('PassLabel', passlabel)

	passentry = model.createInstance(
		'com.sun.star.awt.UnoControlEditModel')
        passentry.PositionX = 55
        passentry.TabIndex = 3
        passentry.Width = 110
        passentry.Height = 10
        passentry.PositionY = 27
        passentry.Align = LEFT
        userentry.Text = login['username']
        passentry.EchoChar = ord('*')
        model.insertByName('PassEntry', passentry)

	bloglabel = model.createInstance(
		'com.sun.star.awt.UnoControlFixedTextModel')
        bloglabel.PositionX = 5
        bloglabel.TabIndex = 3
        bloglabel.Width = 30
        bloglabel.Height = 10
        bloglabel.PositionY = 44
        bloglabel.Align = LEFT
        bloglabel.Label = 'Blog Server:'
        model.insertByName('BlogLabel', bloglabel)

        bloglist = model.createInstance(
		'com.sun.star.awt.UnoControlListBoxModel')
        bloglist.PositionX = 55
        bloglist.TabIndex = 6
        bloglist.Width = 110
        bloglist.Height = 10
        bloglist.PositionY = 44
        bloglist.Dropdown =  True
        model.insertByName('BlogList', bloglist )

	urllabel = model.createInstance(
		'com.sun.star.awt.UnoControlListBoxModel')
        urllabel.PositionX = 5
        urllabel.TabIndex = 3
        urllabel.Width = 45
        urllabel.Height = 10
        urllabel.PositionY = 56
        urllabel.Dropdown =  True
	urllabel.Enabled = False
        model.insertByName('RPCList', urllabel)

	urlentry = model.createInstance(
		'com.sun.star.awt.UnoControlEditModel')
        urlentry.PositionX = 55
        urlentry.TabIndex = 3
        urlentry.Width = 110
        urlentry.Height = 10
        urlentry.PositionY = 56
        urlentry.Align = LEFT
	urlentry.Enabled = False
        model.insertByName('UrlEntry', urlentry)

        ok = model.createInstance(
        	'com.sun.star.awt.UnoControlButtonModel')
        ok.PositionX = 70
        ok.TabIndex = 1
        ok.Height = 12
        ok.Width = 48
        ok.PositionY = 80
        ok.PushButtonType = OK
        ok.DefaultButton =  True
        ok.Label = 'OK'
        model.insertByName('BtnOK', ok )

        cancel = model.createInstance(
        	'com.sun.star.awt.UnoControlButtonModel')
        cancel.PositionX = 120
        cancel.TabIndex = 2
        cancel.Height = 12
        cancel.Width = 48
        cancel.PositionY = 80
        cancel.PushButtonType = CANCEL
        cancel.Label = 'Cancel'
        model.insertByName('BtnExit', cancel )

        frame = model.createInstance(
		'com.sun.star.awt.UnoControlGroupBoxModel')
        frame.PositionX = 1
        frame.TabIndex = 0
        frame.Height = 75
        frame.Width = 170
        frame.PositionY = 1
        frame.Label = 'Configuration'
        model.insertByName('Frame', frame)

	dialog = smgr.createInstanceWithContext(
		'com.sun.star.awt.UnoControlDialog', ctx)

	dialog.setModel(model)

        toolkit = smgr.createInstanceWithContext(
		'com.sun.star.awt.Toolkit', ctx)
        a_rect = uno.createUnoStruct( 'com.sun.star.awt.Rectangle' )
        a_rect.X = model.PositionX
        a_rect.Width = model.Width
        a_rect.Height = model.Height
        a_rect.Y = model.PositionY
        win_descriptor = uno.createUnoStruct(\
		'com.sun.star.awt.WindowDescriptor')
        win_descriptor.Type = TOP
        win_descriptor.ParentIndex = -1
        win_descriptor.Bounds = a_rect
        peer = toolkit.createWindow( win_descriptor )
        dialog.createPeer( toolkit, peer )

	dialog.setTitle ( "Blog Settings" )

	RPCList = dialog.getControl("RPCList")
	RPCList.addItem('ATOM', 1)
#	RPCList.addItem('XML-RPC', 0)
	RPCList.addItem('metaWeblog', 0)


	blogservers = dialog.getControl('BlogList')

	whichserver = ServerListListener(dialog)
	blogservers.addItemListener(whichserver)

	blogservers.addItem('Blogger.com', 0)
	blogservers.addItem('LiveJournal', 1)
	blogservers.addItem('Advogato', 2)
	blogservers.addItem('Other', 3)
	blogservers.selectItemPos(login['servertype'], True)

	ret = dialog.execute()

	blogservers.removeItemListener(whichserver)

	if ret:
		fd = os.open(os.path.expanduser('~/.oooblog'),
			os.O_WRONLY | os.O_CREAT, 0600)
		config = os.fdopen(fd, 'w')
		print >> config, userentry.Text
		print >> config, passentry.Text
		print >> config, \
			blogservers.getSelectedItemPos()
		if blogservers.getSelectedItemPos() == 3:
			print >> config, RPCList.getSelectedItemPos()
			print >> config, urlentry.Text
		else:
			print >> config, login['rpctype']
			print >> config, login['serverurl']
	
		config.close()

def ShowError(text):
	ctx = uno.getComponentContext()
	smgr = ctx.ServiceManager

	model = smgr.createInstanceWithContext(
        	'com.sun.star.awt.UnoControlDialogModel', ctx)
	model.PositionX = 50
        model.Step = 1
        model.TabIndex = 7
        model.Width = 192
        model.Height = 150
        model.PositionY = 63

	label = model.createInstance(
		'com.sun.star.awt.UnoControlFixedTextModel')
        label.PositionX = 5
        label.TabIndex = 3
        label.Width = 180
        label.Height = 10
        label.PositionY = 8
        label.Align = CENTER
        label.Label = 'Connection Error: Check your Blog Settings'
        model.insertByName('Label', label)

	error = model.createInstance(
		'com.sun.star.awt.UnoControlEditModel')
        error.PositionX = 3
        error.TabIndex = 3
        error.Width = 186
        error.Height = 99
        error.PositionY = 30
        error.Align = LEFT
        error.MultiLine = True
        error.HScroll = True
        error.VScroll = True
        error.Text = text
        error.ReadOnly = True
        model.insertByName('Error', error)

        ok = model.createInstance(
        	'com.sun.star.awt.UnoControlButtonModel')
        ok.PositionX = 72
        ok.TabIndex = 1
        ok.Height = 12
        ok.Width = 48
        ok.PositionY = 135
        ok.PushButtonType = OK
        ok.DefaultButton =  True
        ok.Label = 'Close'
        model.insertByName('BtnOK', ok )

        frame = model.createInstance(
		'com.sun.star.awt.UnoControlGroupBoxModel')
        frame.PositionX = 1
        frame.TabIndex = 0
        frame.Height = 113
        frame.Width = 190
        frame.PositionY = 20
        frame.Label = 'Technical Details'
        model.insertByName('Frame', frame)

	dialog = smgr.createInstanceWithContext(
		'com.sun.star.awt.UnoControlDialog', ctx)

	dialog.setModel(model)

        toolkit = smgr.createInstanceWithContext(
		'com.sun.star.awt.Toolkit', ctx)
        a_rect = uno.createUnoStruct( 'com.sun.star.awt.Rectangle' )
        a_rect.X = model.PositionX
        a_rect.Width = model.Width
        a_rect.Height = model.Height
        a_rect.Y = model.PositionY
        win_descriptor = uno.createUnoStruct(\
		'com.sun.star.awt.WindowDescriptor')
        win_descriptor.Type = TOP
        win_descriptor.ParentIndex = -1
        win_descriptor.Bounds = a_rect
        peer = toolkit.createWindow( win_descriptor )
        dialog.createPeer( toolkit, peer )

	dialog.setTitle ( "Blog Error" )

	dialog.execute()

def openpost(apost):
	postdump = tempfile.NamedTemporaryFile()

	# ooo bug, To-Do: log as such
	content = apost.content.replace('<br/>', '<br>')
	print >> postdump, '<html><head><title>' + apost.title + \
		'</title>'
        print >> postdump, \
	  '<META HTTP-EQUIV="CONTENT-TYPE" CONTENT="text/html; charset=utf-8">'
        print >> postdump, '<META NAME="CLASSIFICATION" CONTENT="' + \
		apost.editurl + '">'
	if apost.draft:
		print >> postdump, '<META NAME="KEYWORDS" CONTENT="draft">'
	print >> postdump, '</head>',
	print >> postdump, content.encode('utf-8')
	print >> postdump, '</html>'
	postdump.flush()
	postdumppath = 'file://' + urllib.pathname2url(postdump.name)

        ctx = uno.getComponentContext()
        smgr = ctx.ServiceManager
	desktop = smgr.createInstanceWithContext(\
		"com.sun.star.frame.Desktop", ctx)

	properties=[]
	p = PropertyValue()
	p.Name = "FilterName"
	p.Value = "HTML";
	properties.append(p)

	xDoc = desktop.loadComponentFromURL(postdumppath, '_default', 0, \
		tuple(properties))

	info = xDoc.getDocumentInfo()
	blogtoinfo(apost, info)

g_ImplementationHelper = unohelper.ImplementationHelper()

class BloggerSave( unohelper.Base, XJob ):
        def __init__( self, ctx ):
                self.ctx = ctx
	def execute(self, args):
		SavePost()
                return 1

class BloggerOpen( unohelper.Base, XJob ):
        def __init__( self, ctx ):
                self.ctx = ctx
	def execute(self, args):
		ShowPosts()
                return 1

class BloggerSettings( unohelper.Base, XJob ):
        def __init__( self, ctx ):
                self.ctx = ctx
	def execute(self, args):
		GetSettings()
                return 1

g_ImplementationHelper.addImplementation( \
        BloggerSave,"org.openoffice.pyuno.Blog.Save",
                ("com.sun.star.task.Job",),)

g_ImplementationHelper.addImplementation( \
        BloggerOpen,"org.openoffice.pyuno.Blog.Open",
                ("com.sun.star.task.Job",),)

g_ImplementationHelper.addImplementation( \
        BloggerSettings,"org.openoffice.pyuno.Blog.Settings",
                ("com.sun.star.task.Job",),)
